package tk.antoine_roux.wiki;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.web.servlet.function.RouterFunction;
import org.springframework.web.servlet.function.RouterFunctions;
import org.springframework.web.servlet.function.ServerResponse;

/**
 * Main class
 */
// force spring application to not use glibc or any non jdk code which is bad for graalvm
@SpringBootApplication(proxyBeanMethods = false)
public class MainLauncher {

    @Value("${wikiproject.basePath}")
    private String basePath;

    /**
     * Entrypoint for application
     */
    public static void main(String[] args) {
        SpringApplication.run(MainLauncher.class, args);
    }

    /**
     * Routing declaration
     */
    @Bean
    public RouterFunction<ServerResponse> routes() {
        return RouterFunctions.route()
                .GET(this.basePath + "/hello", serverRequest ->
                        ServerResponse.ok().body("Hello world !")
                ).build();
    }
}
